<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>StatsLogger.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.analytics</a> &gt; <span class="el_source">StatsLogger.java</span></div><h1>StatsLogger.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.analytics;

import io.gitlab.littlesaints.protean.StructuredLoggers;
import lombok.extern.log4j.Log4j2;

import java.util.function.Function;
import java.util.function.Supplier;

/**
 * @author Varun Anand
 * @since 1.0
 */
<span class="fc" id="L33">@Log4j2</span>
public class StatsLogger&lt;E&gt; implements StatsListener&lt;E&gt; {

    private final String eventProcessedLogTemplate;

    private final Function&lt;E, String&gt; idResolver;

    public StatsLogger(Function&lt;E, String&gt; idResolver) {
<span class="fc" id="L41">        this(StructuredLoggers.JSON, idResolver);</span>
<span class="fc" id="L42">    }</span>

<span class="fc" id="L44">    public StatsLogger(Supplier&lt;StructuredLoggers.Format&gt; formatSupplier, Function&lt;E, String&gt; idResolver) {</span>
<span class="fc" id="L45">        eventProcessedLogTemplate = formatSupplier.get()</span>
<span class="fc" id="L46">                .bind(&quot;metric&quot;, String.class)</span>
<span class="fc" id="L47">                .bind(&quot;context&quot;, String.class)</span>
<span class="fc" id="L48">                .bind(&quot;id&quot;, String.class)</span>
<span class="fc" id="L49">                .bind(&quot;stage&quot;, String.class)</span>
<span class="fc" id="L50">                .bind(&quot;start_timestamp&quot;, Long.class)</span>
<span class="fc" id="L51">                .bind(&quot;end_timestamp&quot;, Long.class)</span>
<span class="fc" id="L52">                .bind(&quot;time_taken_millis&quot;, Long.class)</span>
<span class="fc" id="L53">                .build();</span>
<span class="fc" id="L54">        this.idResolver = idResolver;</span>
<span class="fc" id="L55">    }</span>

    @Override
    public void eventProcessed(String context, E event, String name, long startMillis, long endMillis) {
<span class="fc" id="L59">        log.info(eventProcessedLogTemplate, &quot;event_performance&quot;, context, idResolver.apply(event),</span>
<span class="fc" id="L60">                name, startMillis, endMillis,endMillis - startMillis);</span>
<span class="fc" id="L61">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>